using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinExplorerBar;
using System.Reflection;
using Infragistics.Win.UltraWinScrollBar;

namespace WindowsApplication1
{
    public partial class Form1 : Form
    {
        bool isForwardTabbing = true;      
        int previousTabIndex = 0;

        public Form1()
        {
            InitializeComponent();

            this.exbExplorer.KeyDown += new KeyEventHandler(exbExplorer_KeyDown);
            this.exbExplorer.Enter += new EventHandler(exbExplorer_Enter);
         
            foreach (UltraExplorerBarGroup group in this.exbExplorer.Groups)
            {
                group.Container.Enter += new EventHandler(Container_Enter);
                group.Container.Leave += new EventHandler(Container_Leave);

            }


            foreach (Control control in this.Controls)
            {
                // if (control != this.exbExplorer)
                {
                    control.Enter += new EventHandler(control_Enter);
                    control.Leave += new EventHandler(control_Leave);
                }

            }
        }

   
        void control_Leave(object sender, EventArgs e)
        {
            Control c = sender as Control;
            previousTabIndex = c.TabIndex;
        }

        void control_Enter(object sender, EventArgs e)
        {
            Control c = sender as Control;
            if (c.TabIndex > previousTabIndex)
                isForwardTabbing = true;
            else
                isForwardTabbing = false;

        }



        //enter explorer
        private void exbExplorer_Enter(object sender, EventArgs e)
        {
            if (this.exbExplorer.Groups.Count > 0)
            {
                if (isForwardTabbing)
                {
                    this.exbExplorer.Groups[0].Active = true;
                    this.exbExplorer.Groups[this.exbExplorer.ActiveGroup.Index].EnsureGroupHeaderInView();
                }
                else
                {
                    this.exbExplorer.Groups[exbExplorer.Groups.Count - 1].Active = true;
                    this.exbExplorer.Groups[this.exbExplorer.ActiveGroup.Index].EnsureGroupHeaderInView();

                }

            }
        }


        //eneter a group
        void Container_Enter(object sender, EventArgs e)
        {
            UltraExplorerBarContainerControl container = sender as UltraExplorerBarContainerControl;
            foreach (Control control in container.Controls)
            {
                if (control.CanFocus)
                {
                    control.TabStop = true;
                }
            }
        }

        //leave a group
        void Container_Leave(object sender, EventArgs e)
        {
            UltraExplorerBarContainerControl container = sender as UltraExplorerBarContainerControl;

            foreach (Control control in container.Controls)
            {
                if (control.CanFocus)
                {
                    control.TabStop = false;
                }

            }
            UltraExplorerBarGroup group = findGroup(container);

            if (group != null)
            {
                if (isForwardTabbing)
                {
                    int index = group.Index + 1;
                    if (index < this.exbExplorer.Groups.Count)
                    {
                        this.exbExplorer.Groups[index].Active = true;
                        this.exbExplorer.Focus();
                    }

                }
                else
                {
                    //int index = group.Index - 1;
                    //if (index > -1)
                    //{

                    //    this.exbExplorer.Groups[index].Active = true;
                    //    this.exbExplorer.Focus();
                    //}
                }
            }
        }

        private void focusFirstControl(UltraExplorerBarGroup group)
        {
            if (group!= null && group.Expanded)
            {
                foreach (Control control in this.exbExplorer.ActiveGroup.Container.Controls)
                {
                    if (control.CanFocus)
                    {
                        control.TabStop = true;
                    }
                }
                this.exbExplorer.Groups[this.exbExplorer.ActiveGroup.Index].EnsureGroupHeaderInView();
                if (group.Container.Controls.Count > 0)
                {
                    int minTabIndex = group.Container.Controls[0].TabIndex;
                    int controlWithMinTabIndex = 0;
                    for (int i = 0; i < group.Container.Controls.Count; i++)
                    {
                        if (group.Container.Controls[i].CanSelect
                            && minTabIndex > group.Container.Controls[i].TabIndex)
                        {
                            minTabIndex = group.Container.Controls[i].TabIndex;
                            controlWithMinTabIndex = i;
                        }
                    }


                    group.Container.Controls[controlWithMinTabIndex].Focus();
                    this.exbExplorer.Groups[this.exbExplorer.ActiveGroup.Index].EnsureGroupHeaderInView();
                    // container.ScrollControlIntoView( container.Controls[controlWithMinTabIndex]);

                    this.exbExplorer.EnsureActiveControlInView(true);
                }
            }
        }


        private void focusLastControl(UltraExplorerBarGroup group)
        {
            //this.exbExplorer.Groups[this.exbExplorer.ActiveGroup.Index].EnsureGroupHeaderInView();
            if (group != null && group.Expanded)
            {
                foreach (Control control in group.Container.Controls)
                {
                    if (control.CanFocus)
                    {
                        control.TabStop = true;

                    }
                    // make it visible
                }

                if (group.Container.Controls.Count > 0)
                {
                    int maxTabIndex = group.Container.Controls[group.Container.Controls.Count - 1].TabIndex;
                    int controlWithMaxTabIndex = 0;
                    for (int i = 0; i < group.Container.Controls.Count; i++)
                    {
                        if (group.Container.Controls[i].CanSelect
                            && maxTabIndex < group.Container.Controls[i].TabIndex)
                        {
                            maxTabIndex = group.Container.Controls[i].TabIndex;
                            controlWithMaxTabIndex = i;
                        }
                    }

                    group.Container.Controls[controlWithMaxTabIndex].Focus();
                    //  group.Container.Controls[controlWithMaxTabIndex].Show();
                    //this.exbExplorer.Groups[this.exbExplorer.ActiveGroup.Index].EnsureGroupHeaderInView();
                    //container.ScrollControlIntoView( container.Controls[controlWithMinTabIndex]);

                    this.exbExplorer.EnsureActiveControlInView(true);
                }
            }
        }

        private void exbExplorer_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Tab && !e.Shift)
            {
                this.exbExplorer.ActiveGroup.EnsureGroupHeaderInView();
                focusFirstControl(this.exbExplorer.ActiveGroup);

                //this.exbExplorer.EnsureActiveControlInView(true);
                isForwardTabbing = true;
            }
            else if (e.KeyCode == Keys.Tab && e.Shift)
            {
                this.exbExplorer.ActiveGroup.EnsureGroupHeaderInView();

                int index = this.exbExplorer.ActiveGroup.Index - 1;
                 if (index > -1)
                 {

                     focusLastControl(this.exbExplorer.Groups[index]);
                 }
                isForwardTabbing = false;
            }
        }



        private UltraExplorerBarGroup findGroup(UltraExplorerBarContainerControl container)
        {
            UltraExplorerBarGroup foundGroup = null;
            foreach (UltraExplorerBarGroup group in ((UltraExplorerBar)container.Parent).Groups)
            {
                if (group.Container == container)
                {
                    foundGroup = group;
                    break;
                }
            }

            return foundGroup;
        }


    }
}